#!/bin/bash

# shellcheck disable=SC2154
# shellcheck source=/dev/null

. /usr/share/univention-lib/ucr.sh

eval "$(ucr shell hostname domainname samba4/role ldap/server/name)"

trivial_ddns_update_by_dns_server_principal() {
	local rc
	kdestroy || true
	kinit -t /var/lib/samba/private/dns.keytab "dns-$hostname" || return $?
	echo -e "server $hostname.$domainname\nprereq yxdomain $domainname\n" | nsupdate -g
	rc=$?
	kdestroy
	return "$rc"
}

trivial_ddns_update_by_machine_principal() {
	local rc
	echo -e "server ${ldap_server_name}\nprereq yxdomain $domainname\n" | nsupdate -g
	rc=$?
	return "$rc"
}

# Check that the DNS infomation can be updated using the machine credentials.
# Do not execute on UCS@school multi server master/backup.
if ! univention-ldapsearch "(&(|(univentionServerRole=master)(univentionServerRole=backup))(cn=$hostname)(univentionService=UCS@school)(!(univentionService=S4 Connector)))" dn | grep -q '^dn:'; then
  if univention-ldapsearch univentionService="S4 Connector" dn | grep -q "^dn:"; then
    kdestroy || true
    if kinit --password-file=/etc/machine.secret "$hostname$"; then
      trivial_ddns_update_by_machine_principal
      kdestroy
    fi
  fi
fi

if [ "$samba4_role" = "DC" ]; then
	trivial_ddns_update_by_dns_server_principal
fi
