#!/bin/bash

. /usr/share/univention-lib/ucr.sh

eval "$(ucr shell hostname samba4/role)"

check_msds_keyversionnumber() {
	local account
	account="$1"
	sam_kvno=$(ldbsearch -H /var/lib/samba/private/sam.ldb \
		sAMAccountName="$account" msDS-KeyVersionNumber \
		| sed -n 's/^msDS-KeyVersionNumber: //p')
	local_kvno=$(ldbsearch -H /var/lib/samba/private/secrets.ldb \
		sAMAccountName="$account" msDS-KeyVersionNumber \
		| sed -n 's/^msDS-KeyVersionNumber: //p')
	if [ "$sam_kvno" != "$local_kvno" ]; then
		echo "ERROR: The msDS-KeyVersionNumber for $account is not consistent"
		echo "       msDS-KeyVersionNumber in SAM: $sam_kvno"
		echo "       msDS-KeyVersionNumber in secrets.ldb: $local_kvno"
	fi
}

if [ "$samba4_role" = "DC" ]; then
	check_msds_keyversionnumber "$hostname$"
fi
