#!/bin/bash

. /usr/share/univention-lib/admember.sh

if is_domain_in_admember_mode; then
	echo "Skipping test, domain is in AD member mode"
	exit 0
fi

samba3=false
samba4=false
univention-ldapsearch "(&(cn=$(hostname))(univentionService=Samba 3))" dn | grep -q '^dn: ' && samba3=true
univention-ldapsearch "(&(cn=$(hostname))(univentionService=Samba 4))" dn | grep -q '^dn: ' && samba4=true

set +e
ret=0

if $samba3 || $samba4; then
	if [ -x /etc/init.d/samba ]; then
		dom=rpc
		if [ "$(ucr get server/role)" = "memberserver" ]; then
			if [ "$(ucr get samba/domain/security)" = "ads" ]; then
				dom=ads
			fi
		fi
		net $dom testjoin
		ret=$?
	fi
fi

exit $ret
